//
// Common useful functions
//

// ceil(ilog2(a))
function int ilog2c(int a);
  int b = 0;
   while ((1 << b) < a)
     b++;
   ilog2c = b;
endfunction // ilog2c

// floor(ilog2(a))
function int ilog2f(int a);
  ilog2f = ilog2c(a+1)-1;
endfunction // ilog2f

function int max(int a, int b);
  max = a > b ? a : b;
endfunction // max

function int max3(int a, int b, int c);
  max3 = max(max(a,b),c);
endfunction // max3

function int max4(int a, int b, int c, int d);
  max4 = max(max(a,b),max(c,d));
endfunction // max4

function int min(int a, int b);
  min = a < b ? a : b;
endfunction // min

function int min3(int a, int b, int c);
  min3 = min(min(a,b),c);
endfunction // min3

function int min4(int a, int b, int c, int d);
  min4 = min(min(a,b),min(c,d));
endfunction // min4
